#     FILENAME PATTERNS ARE PRESENT
setMethod("getFlowJoGates",
          signature(fj="flowJoObj"), 
          definition = function(fj, fileNamePatterns=".") {
  
  index  <- lapply(fileNamePatterns, function(x) { grep(x, fj@FCSFilename) });  
  index  <- unique(unlist(index));
  dat    <- list(fcsName      = fj@fcsName[index],
                  FCSFilename = fj@FCSFilename[index],
                  filter      = fj@filter[index],
                  filterName  = fj@filterName[index],
                  compMats    = fj@uniCompList[ fj@useCompMatrix[index] ]); 
  return(dat);
});




setMethod("getFlowJoGates",
          signature(fj="flowJoList"), 
          definition = function(fj, fileNamePatterns=".") {
          
  dat <- sapply(fj@flowJoData, getFlowJoGates, fileNamePatterns=fileNamePatterns); 
  resultsDat = list(fcsName     = unlist(dat["fcsName",]),
                    FCSFilename = unlist(dat["FCSFilename",]),
                    filter      = unlist(dat["filter",]),
                    filterName  = unlist(dat["filterName",]),
                    compMats    = unlist(dat["compMats",], recursive=FALSE));
 
  return(resultsDat);
});



