readFlowJoList <- function(workspaceVec, altFileLocation="") {

  workspaceVec  <- unique(workspaceVec);
  aFlowJoList   <- new("flowJoList");

  if ((length(altFileLocation) == 1) & (length(workspaceVec) > 1)) {
     altFileLocation = rep(altFileLocation, length(workspaceVec));
  }
  
  for (wsNum in 1:length(workspaceVec)) {
    aWS           <- workspaceVec[wsNum];
    cat(paste("\nGetting a workspace for: ", basename(aWS), "... ", sep=''));
    flowJoDOM     <- readFlowJoFile(aWS);
    cat("got it!\n")
    gateList      <- gatherFlowJoGates(flowJoDOM, altFileLocation[wsNum]);
    compList      <- getFlowJoCompMatrix(flowJoDOM);
    transList     <- gatherFlowJoTransformations(flowJoDOM);
    flowJoVersion <- getFlowJoVersion(flowJoDOM);
    updateDate    <- file.info(aWS)$mtime;
    free(flowJoDOM);      # BIGGEST MEMORY LEAK!!!
#print("Gold -- got the gateList");  print(str(gateList));

    # Next, a couple of inches of code to 'unique-ify' the compensation
    # matricies so there are only a few per FlowJoWorkspace
    uniCompList  <- unique(compList);    
    compLookUp   <- vector(mode='numeric', length=length(gateList$fcsName));
    
    for (anFCSfile in unique(gateList$fcsName)) {
      for (i in 1:length(uniCompList)) {
        if (isTRUE(all.equal(compList[[anFCSfile]], uniCompList[[i]]))) {
          index = gateList$fcsName == anFCSfile;
          compLookUp[index] = i;
        }
      }
    }


    # Now store all the collected data for this workspace and move to the next one.
    aFlowJoObj = new("flowJoObj",  fcsName         = gateList$fcsName,
                                   filterName      = gateList$filterName,
                                   filter          = gateList$filter,
                                   terminalFilter  = gateList$terminalFilter,
                                   FCSFilename     = gateList$fcsPath,
                                   useCompMatrix   = compLookUp,
                                   uniCompList     = uniCompList,
                                   transformList   = transList); 
    
    aFlowJoList@FlowJoWorkspace[wsNum] = aWS;
    aFlowJoList@flowJoVersion[wsNum]   = flowJoVersion; 
    aFlowJoList@updateDate[wsNum]      = updateDate;
    aFlowJoList@flowJoData[wsNum]      = aFlowJoObj;
  }
  cat(" done! \n\n\n");
  return(aFlowJoList);

}
  



