
setMethod("simplifyGateNames",
          signature(x = "character"), 
          definition = function(x, 
                                upperCaseGates=FALSE, 
                                stripFileName=TRUE,
                                removeParentalNames=FALSE) {
          
  if (upperCaseGates == TRUE) { x = toupper(x); }
  
  if (stripFileName  == TRUE) { 
    x <- gsub(".*\\.fcs:", "", x, perl=TRUE, ignore.case=TRUE);
  }
  
  if (removeParentalNames == TRUE) {
    x <- gsub(".*:", "", x, perl=TRUE, ignore.case=TRUE);
  }

  x <- gsub("(\\s+)?Lymphocyte[s]?(\\s+)?",  "Lymphocytes",  x, perl=TRUE, ignore.case=TRUE);
  x <- gsub("(\\s+)?Monocyte[s]?(\\s+)?",    "Monocytes",    x, perl=TRUE, ignore.case=TRUE);
  x <- gsub("(\\s+)?Granulocyte[s]?(\\s+)?", "Granulocytes", x, perl=TRUE, ignore.case=TRUE);
  
  x <- gsub("\\s?pos(itive\\s+cells?)?(\\s+)?", "\\+", x, perl=TRUE, ignore.case=TRUE);
  x <- gsub("\\s?neg(ative\\s+cells?)?(\\s+)?", "\\-", x, perl=TRUE, ignore.case=TRUE);
  x <- gsub("(\\w+)\\s+([\\+\\-])", "\\1\\2",   x, perl=TRUE);
  x <- gsub("(\\s)?([cC][dD]\\d+[a-z]?[\\+\\-])(\\s)?", "\\U\\2", x, perl=TRUE);

  return(x);
});   
  

setMethod("simplifyGateNames",
          signature(x = "filter"), 
          definition = function(x, 
                                upperCaseGates=FALSE, 
                                stripFileName=TRUE,
                                removeParentalNames=FALSE) {
  filterName = x@filterId;
  filterName = simplifyGateNames(filterName);
  x@filterId <- filterName;
  return(x);
});


