\name{getFlowJoSummary}
\alias{getFlowJoSummary}
\title{ Summarize FlowJo Workspaces }

\description{
  Makes a table of the number and count of various gates, possibly broken out by FCS file in one or more FlowJo workspaces.
}
\usage{
getFlowJoSummary(x, gatesByFile=TRUE, fileNamePatterns=".", \dots)
}

\arguments{
  \item{x}{ a flowJoList or flowJoObj }
  \item{gatesByFile}{ a boolean.  If TRUE (default) then the count of each gate type will be broken out for each referenced FCS file.  Otherwise this method will just return a table with the total counts of each named gate listed in the FlowJo workspace(s). }
  \item{fileNamePatterns}{ A list of patterns for picking out specific FCS files.  Default = "."  (ie. examines all of the FCS files) }
  \item{\dots}{ Additional arguments: to simplifyGateNames such as stripFileName and removeParentalNames }
}

\value{
The method getFlowJoSummary returns a table summarizing the number of gates listed in the referenced FlowJo workspaces.  This function is useful for ensuring that the  cytometrist has used a consistent set of names in their process.

}

\references{ See also FlowJo from Treestar Inc, at:  \url{http://www.flowjo.com/} }
\author{ John Gosink }

\examples{

demoLocation <- system.file("extdata", "DemoWorkspace.wsp", package="flowFlowJo"); 
actualFCSLoc <- system.file("extdata/fcsFiles", package="flowFlowJo"); 
testList     <- readFlowJoList(demoLocation, altFileLocation=actualFCSLoc);

getFlowJoSummary(testList, gatesByFile=FALSE, removeParentalNames=TRUE);

}

